use32

db "MZ",0
LoadLibraryName:
	db "LoadLibraryA",0
pesig:
	dd "PE"				; PE signature
	dw 0x014C			; Machine (Intel 386)
	dw 1				; NumberOfSections
kernel32:
	db "KERNEL32"
idata:												; Import Table fields:
	dd 0											;	HintTable (need 0)
	dw csect-8-opthdr	; SizeOfOptionalHeader
	dw 0x10F;+0x2000 	; 100-32bit, 8-noDbgSym, 4-noLineNum, 2-Executable, 1-NoReloc
			;+0x2000 - DLL / Entry point: DllMain(hmodule,reason,reserved)
opthdr:					; PE optional header
	dw 0x10B			; Magic (PE32)
	db "mr"	 ; my runtime signature
	dd 0x1000+kernel32								;	DllName
	dd 0x1000+kernel32_iat							;	ThunkTable
; @34
skip3:
		add edi, esi	; decompressed code destination
		jmp short skip4
	dd 0x1000+startPE	; AddressOfEntryPoint
;@3C
	dd pesig			; MZ header: pointer to PE header
	dd 0				;							;	DllName=0 terminator
	dd 0x400000			; PE ImageBase
	dd 0x1000			; SectionAlignment	; 1000h works on Win98, XP, and Wine
	dd 0x200			; FileAlignment		; Win XP needs multiple of 200h here
skip2:
		pop	ebp
		lea esi, [ebp-stPEret+codeend]
		db 0xEB ;jmp short +03
		dw 03	;@58	; MajorSubsystemVersion ; Windows version needs to be >= 3.10
		dw 10	;@5A	; MinorSubsystemVersion ;
		lodsd ; decomp_dest_offset
		xchg eax, edi
		jmp short skip3
;@60
	dd '????'			; SizeOfImage (must be aligned hdrsize + sum of all sections virtual sizes)
	dd 0x1000			; SizeOfHeaders - loader reads headers to PE_IMAGE_BASE and makes a ro page
skip4:
		xor	eax, eax; nc
		jmp short skip5
	dw 3;2				; Win32 Subsystem ; 2-GUI, 3-Console ; for more info search: msdn ms680339
	dw 0x8F00			; DllCharacteristics: 8000=TSaware,800=noBind,400=noSEH,200=noManifest,100=NXcompat,40-Relocatable
	dd 0x100000			; SizeOfStackReserve 1M ; Win32: initial esp = ~4Mb - reserve
	dd 0x1000			; SizeOfStackCommit  4k
	;dd 0x100000	;@78; SizeOfHeapReserve ; need to be some reasonable size ~?Mb
	;dd 0x1000		;@7C; SizeOfHeapCommit  4k
startPE:
	db 0E8h	;call startPE2
	dd startPE2-$-4
stPEret:
	db 10h, 0, 0
startPE2:
		mov ebx, esp
		jmp short skip2
	times (84h-$) db 'x'

	dd 2				; NumberOfRvaAndSizes (data directories)
	dd 0;,0				; Export Table (0,?)
skip5:
	inc eax
	push eax;=1
	jmp short skip6
	dd idata+0x1000		; Import Table Addr must be >= 0x1000
	dd 16				; Import Table Size: Win9x needs size>0, XP doesn't care
	dd 0;@98,?			; Resource table; Win9x needs addr=0 regardless of #ddirs
	;dd ?,0 @BC			; Debugging information address and size (size must be 0)
	;dd 0 @D0,?			; Thread Local Storage (TLS) table (addr must be 0)
	;dd ?,0 @FC			; The CLR header address and size (if size!=0 linux loader assumes .net)

;startPE2:
;		pop ebp
;		lea esi, [ebp-stPEret+codeend]
;		lodsd ; decomp_dest_rva
;		lea edi, [esi+eax] ; decompressed code destination
skip6:

decompress32:

		; esi=src, edi=dst_base

		;xor	eax, eax; nc
		;inc	eax
		;;push eax	; 1 ; need byte [ebx+5]==0 ; byte [ebx] of module base already == 0
		;push eax	; 1
		;mov ebx, esp

load_ecx: ;cf
		xchg eax, ecx
		lodsd		; load next dword from control stream
		jc get_bit
		xchg eax, edx
		; after pop eax=1, ecx=1, edx=initial control dword
dsave:
		pop eax
		push edi
		push edi
ddown:
		xchg edi, [esp+4*ecx]
		loop ddown
dcopy:
		xchg esi, [esp]
		rep movsb	; if ecx==0 rep does nothing
		pop esi
dmove:
		rep movsb

next_len:
		lea ecx, [edx-1]	; control word
		xor ch, ch	; nc
		; must come here with nc
prefix_bit:
		inc cl				; range -pp..0
		jmp short skip7

	times (0xBC-$-2) db 'x' mod 100h
imp_done:
	db 0xC2, 4 ; ret 4
	dd 0				; Debug dir size @BC
csect:
	dd '????'			; VirtualSize
	dd 0x1000			; VirtualAddress
	dd '????'			; SizeOfRawData (in file)
	;dd 1        		; PointerToRawData (rounded on 0x200 down to 0), but not on ReactOS
kernel32_iat:
LoadLibraryFptr:
		dd LoadLibraryName - 2;, 0
	dd 0				; TLS addr @D0
skip7:
		ja get_bit			; nz & nc
		sbb cl, dl			; shift range to 0..pp-1,pp
		jnc get_bit

		;jmp short skip8
		;times (csect+1Ch-$) db 'x'
		;dd 0xF0000020		; Characteristics: (x2=execute, x4=read, x8=write, x1=shareable, 20=code)
;skip8:
		;dd 0xE9D3E9D2		; opcodes for shr instructions give some crazy but working characteristics

		add cl, dh
		shr cl, cl
		shr ecx, cl
get_bit:
		xchg eax, ecx
		rcr ecx, 1			; get bit from control stream
		jecxz load_ecx
		xchg eax, ecx
		js  prefix_bit
		rcl ecx, 1			; copy fixed bits into result
		jnc get_bit
op2_bit:					; after move [ebx]==dl else 0
		inc ecx
		xor [ebx], dl		; byte[ebx] is guaranteed to be 0 initially
		rcr ecx, 1
		ja  dmove	; nc & nz	; [ebx]!=0
		jnz op2_bit	;  c & nz


		inc ecx
		jnc dcopy	; nc &(z)	; [ebx]==0
					;  c &(z)	; [ebx]==0
		push eax

;			times (0xFC-1-$) db 90h
;			db 0xe9 ; jmp long 0
;			dd 0; @fc ; unless CLR ddir size==0 linux loader tries to load mono
;		lea eax, [esp+4*ecx]

		times (0xFC-3-$) db 90h
;		lea eax, [esp+4*ecx+00000000]
		db 0x8D,0x84,0x8C, 0, 0, 0, 0

		sbb eax, ebx
		sar eax, 3
		js dsave	; s, nz, c/nc
		dec eax
		jnc	dint32
;base:
		add eax, [ebx]	; compute base+offset ; nc,nz,ns ; if eax was -1 -> cf -> exit
dint32:
		stosd
		pop eax
		jnc next_len	; nc & nz after base

		; DLL imports on Win32

		pop esi ; dll import list
imp_next_dll:
		lodsd			; next dll name
		xchg eax, ecx
		jecxz imp_done 	; end of list
		push ecx
		lodsd
		xchg eax, edi ; dll ttab addr
		call dword [ebp-stPEret + LoadLibraryFptr] ; LoadLibrary ; stdcall ret 4
		pushad
		xchg eax, ebx ; ebx=hmodule (dll base)
		mov esi, [ebx+0x3C] ; pe offset
		mov esi, [ebx+esi+0x78] ; export dir rva
		lea esi, [ebx+esi+0x18] ; export dir addr + 0x18
		lodsd	; +18 ; count
		xchg eax, ecx ; count
		lodsd		; +1Ch ; funcs[] rva
		lea edx, [ebx+eax] ; funcs[] addr
		lodsd		; +20h ; names rva
		mov ebp, [esi];+24 ; ordinals rva
		lea esi, [ebx+eax] ; names addr
imp_next_name:
		lodsd	; eax = exported function name
		pushad
		; h=5381;=1505h; compute djb2 hash
		; do{ h=(h*33)^(*p); } while(*p++);
		lea esi, [ebx+eax]; dll base + func name
		mov ch,15h	; ecx=5381=1505h
		mov cl,05h
hash_char:
		imul ecx, ecx, 33
		lodsb
		xor cl, al
		das	; ZF will be set only if al==0
		jne hash_char
		xchg eax, ecx	; eax = hash
ttab_next:
		mov ecx, [edi]
		jecxz ttab_end
		scasd           ; hash - *ttab 
		jne ttab_next
		;get function ptr
		movzx eax, word [ebx+ebp]; func ordinal
		add ebx, [edx+4*eax]  	 ; func addr + base
		mov [edi-4], ebx
ttab_end:
		popad
		inc ebp ; next ordinal
		inc ebp
		loop imp_next_name
		popad
		jmp short imp_next_dll
codeend:
fileend:
