use16

; Assuming loaded by boot sector at 60h:00h
; ss:sp somewhere at the top of conv memory, ss:bp->bpb
; cs=ds=60h, dl=disk#, {cld, bh=0, cx=ip=0(MZ->200), si=2} (si:)di=first cluster of a file

		cli
		mov bl, 10h
		lgdt [gdt+6+bx-10h]

		mov eax, cr0
		inc ax ;PE=1
		mov cr0, eax
		db 0eah,pm32 ;jmp 8:600h+pm32
gdt:;align 8
		db     6,8,0,0,0,9Ah,0cfh,0 ;code32
		db gdt-8,6,0,0,0,92h,0cfh,0 ;data32
use32
pm32:
		mov ds, bx
		mov ss, bx
		mov esp, 20000h ; exe+stack<128k ; decompressed code+data to 128k..640k
		pushad	; dl=boot disk#
		mov esi, 600h+codeend

		xor	eax, eax; nc
		inc	eax
		push eax	; 1
		mov ebx, esp
		les edi,[ebx+16]

load_ecx: ;cf
		xchg eax, ecx
		lodsd		; load next dword from control stream
		jc get_bit
		xchg eax, edx
		; after pop eax=1, ecx=1, edx=initial control dword
dsave:
		pop eax
		push edi
		push edi
ddown:
		xchg edi, [esp+4*ecx]
		loop ddown
dcopy:
		xchg esi, [esp]
		rep movsb	; if ecx==0 rep does nothing
		pop esi
dmove:
		rep movsb

next_len:
		lea ecx, [edx-1]	; control word
		xor ch, ch	; nc
		; must come here with nc
prefix_bit:
		inc cl				; range -pp..0
		ja get_bit			; nz & nc
		sbb cl, dl			; shift range to 0..pp-1,pp
		jnc get_bit
		add cl, dh			;
		shr cl, cl
		shr ecx, cl
get_bit:
		xchg eax, ecx
		rcr ecx, 1			; get bit from control stream
		jecxz load_ecx
		xchg eax, ecx
		js  prefix_bit
		rcl ecx, 1			; copy fixed bits into result
		jnc get_bit
op2_bit:					; after move [ebx]==dl else 0
		inc ecx
		xor [ebx], dl		; guaranteed to be 0 initially
		rcr ecx, 1
		ja  dmove	; nc & nz	; [ebx]!=0
		jnz op2_bit	;  c & nz
		inc ecx
		jnc dcopy	; nc &(z)	; [ebx]==0
					;  c &(z)	; [ebx]==0
		push eax
		lea eax,[esp+4*ecx]
		sbb eax, ebx
		sar eax, 3
		js dsave	; s, nz, c/nc
		dec eax
		jnc	dint32
;base:
		add eax, [ebx]	; compute base+offset ; nc,nz,ns ; exit if eax was -1 -> cf
dint32:
		stosd
		pop eax
		jnc next_len	; nc & nz after base
		ret
codeend:
